diff --git a/example/ipsec/README b/example/ipsec/README
index 73c8437..319bfc2 100644
--- a/example/ipsec/README
+++ b/example/ipsec/README
@@ -167,3 +167,5 @@ BASH batch files are now included to run several simple loopback tests that
 do not require any packet IO.  The scripts create internal "loopback" (not
 real Linux loopback interfaces but simply ODP queues) as opposed to packet
 interfaces.
+Before running the example bash scripts add odp_ipsec to your PATH
+export PATH="<path_to_odp_ipsec>:$PATH"
diff --git a/example/ipsec/run_ah_in.sh b/example/ipsec/run_ah_in.sh
index 5ff1687..252f44b 100755
--- a/example/ipsec/run_ah_in.sh
+++ b/example/ipsec/run_ah_in.sh
@@ -4,7 +4,7 @@
 #  - 2 loop interfaces
 #  - 10 packets
 #  - Specify API mode on command line
-./odp_ipsec -i loop1,loop2 \
+odp_ipsec -i loop1,loop2 \
 -r 192.168.111.2/32:loop1:08.00.27.76.B5.E0 \
 -p 192.168.222.0/24:192.168.111.0/24:in:ah \
 -a 192.168.222.2:192.168.111.2:md5:300:27f6d123d7077b361662fc6e451f65d8 \
diff --git a/example/ipsec/run_ah_out.sh b/example/ipsec/run_ah_out.sh
index b78193e..9256c07 100755
--- a/example/ipsec/run_ah_out.sh
+++ b/example/ipsec/run_ah_out.sh
@@ -4,7 +4,7 @@
 #  - 2 loop interfaces
 #  - 10 packets
 #  - Specify API mode on command line
- ./odp_ipsec -i loop1,loop2 \
+odp_ipsec -i loop1,loop2 \
 -r 192.168.222.2/32:loop2:08.00.27.F5.8B.DB \
 -p 192.168.111.0/24:192.168.222.0/24:out:ah \
 -a 192.168.111.2:192.168.222.2:md5:200:a731649644c5dee92cbd9c2e7e188ee6 \
diff --git a/example/ipsec/run_both_in.sh b/example/ipsec/run_both_in.sh
index 502f14a..c3f169c 100755
--- a/example/ipsec/run_both_in.sh
+++ b/example/ipsec/run_both_in.sh
@@ -4,7 +4,7 @@
 #  - 2 loop interfaces
 #  - 10 packets
 #  - Specify API mode on command line
-./odp_ipsec -i loop1,loop2 \
+odp_ipsec -i loop1,loop2 \
 -r 192.168.111.2/32:loop1:08.00.27.76.B5.E0 \
 -p 192.168.222.0/24:192.168.111.0/24:in:both \
 -a 192.168.222.2:192.168.111.2:md5:300:27f6d123d7077b361662fc6e451f65d8 \
diff --git a/example/ipsec/run_both_out.sh b/example/ipsec/run_both_out.sh
index 3086e6f..8ba0672 100755
--- a/example/ipsec/run_both_out.sh
+++ b/example/ipsec/run_both_out.sh
@@ -4,7 +4,7 @@
 #  - 2 loop interfaces
 #  - 10 packets
 #  - Specify API mode on command line
-./odp_ipsec -i loop1,loop2 \
+odp_ipsec -i loop1,loop2 \
 -r 192.168.222.2/32:loop2:08.00.27.F5.8B.DB \
 -p 192.168.111.0/24:192.168.222.0/24:out:both \
 -e 192.168.111.2:192.168.222.2:\
diff --git a/example/ipsec/run_esp_in.sh b/example/ipsec/run_esp_in.sh
index a206cc4..12fdae6 100755
--- a/example/ipsec/run_esp_in.sh
+++ b/example/ipsec/run_esp_in.sh
@@ -4,7 +4,7 @@
 #  - 2 loop interfaces
 #  - 10 packets
 #  - Specify API mode on command line
-./odp_ipsec -i loop1,loop2 \
+odp_ipsec -i loop1,loop2 \
 -r 192.168.111.2/32:loop1:08.00.27.76.B5.E0 \
 -p 192.168.222.0/24:192.168.111.0/24:in:esp \
 -e 192.168.222.2:192.168.111.2:\
diff --git a/example/ipsec/run_esp_out.sh b/example/ipsec/run_esp_out.sh
index b5a541e..73c4ff0 100755
--- a/example/ipsec/run_esp_out.sh
+++ b/example/ipsec/run_esp_out.sh
@@ -4,7 +4,7 @@
 #  - 2 loop interfaces
 #  - 10 packets
 #  - Specify API mode on command line
-./odp_ipsec -i loop1,loop2 \
+odp_ipsec -i loop1,loop2 \
 -r 192.168.222.2/32:loop2:08.00.27.F5.8B.DB \
 -p 192.168.111.0/24:192.168.222.0/24:out:esp \
 -e 192.168.111.2:192.168.222.2:\
diff --git a/example/ipsec/run_live.sh b/example/ipsec/run_live.sh
index f61d4e3..90947ad 100755
--- a/example/ipsec/run_live.sh
+++ b/example/ipsec/run_live.sh
@@ -3,7 +3,7 @@
 # Live router test
 #  - 2 interfaces interfaces
 #  - Specify API mode on command line
-sudo ./odp_ipsec -i p7p1,p8p1 \
+sudo odp_ipsec -i p7p1,p8p1 \
 -r 192.168.111.2/32:p7p1:08.00.27.76.B5.E0 \
 -r 192.168.222.2/32:p8p1:08.00.27.F5.8B.DB \
 -p 192.168.111.0/24:192.168.222.0/24:out:both \
diff --git a/example/ipsec/run_router.sh b/example/ipsec/run_router.sh
index 55ad766..3630297 100755
--- a/example/ipsec/run_router.sh
+++ b/example/ipsec/run_router.sh
@@ -3,7 +3,7 @@
 # Live router test
 #  - 2 interfaces interfaces
 #  - Specify API mode on command line
-sudo ./odp_ipsec -i p7p1,p8p1 \
+sudo odp_ipsec -i p7p1,p8p1 \
 -r 192.168.111.2/32:p7p1:08.00.27.76.B5.E0 \
 -r 192.168.222.2/32:p8p1:08.00.27.F5.8B.DB \
 -c 1 -m $1
diff --git a/example/ipsec/run_simple.sh b/example/ipsec/run_simple.sh
index 4622791..1211583 100755
--- a/example/ipsec/run_simple.sh
+++ b/example/ipsec/run_simple.sh
@@ -4,7 +4,7 @@
 #  - 2 loop interfaces
 #  - 10 packets
 #  - Specify API mode on command line
-./odp_ipsec -i loop1,loop2 \
+odp_ipsec -i loop1,loop2 \
 -r 192.168.222.2/32:loop2:08.00.27.F5.8B.DB \
 -s 192.168.111.2:192.168.222.2:loop1:loop2:10:100 \
 -c 2 -m $1