diff --git a/example/generator/Makefile.am b/example/generator/Makefile.am
index d766f79..fcb5965 100644
--- a/example/generator/Makefile.am
+++ b/example/generator/Makefile.am
@@ -4,4 +4,7 @@ bin_PROGRAMS = odp_generator
 odp_generator_LDFLAGS = $(AM_LDFLAGS) -static
 odp_generator_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
 
+noinst_HEADERS = \
+		  $(top_srcdir)/example/example_debug.h
+
 dist_odp_generator_SOURCES = odp_generator.c
diff --git a/example/ipsec/Makefile.am b/example/ipsec/Makefile.am
index f0a8d1d..1c6fd32 100644
--- a/example/ipsec/Makefile.am
+++ b/example/ipsec/Makefile.am
@@ -4,6 +4,16 @@ bin_PROGRAMS = odp_ipsec
 odp_ipsec_LDFLAGS = $(AM_LDFLAGS) -static
 odp_ipsec_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
 
+noinst_HEADERS = \
+		  $(top_srcdir)/example/ipsec/odp_ipsec_cache.h \
+		  $(top_srcdir)/example/ipsec/odp_ipsec_fwd_db.h \
+		  $(top_srcdir)/example/ipsec/odp_ipsec_loop_db.h \
+		  $(top_srcdir)/example/ipsec/odp_ipsec_misc.h \
+		  $(top_srcdir)/example/ipsec/odp_ipsec_sa_db.h \
+		  $(top_srcdir)/example/ipsec/odp_ipsec_sp_db.h \
+		  $(top_srcdir)/example/ipsec/odp_ipsec_stream.h \
+		  $(top_srcdir)/example/example_debug.h
+
 dist_bin_SCRIPTS = \
 		   $(srcdir)/run_ah_in.sh \
 		   $(srcdir)/run_ah_out.sh \
diff --git a/example/l2fwd/Makefile.am b/example/l2fwd/Makefile.am
index 17f0d8f..feced2a 100644
--- a/example/l2fwd/Makefile.am
+++ b/example/l2fwd/Makefile.am
@@ -4,4 +4,7 @@ bin_PROGRAMS = odp_l2fwd
 odp_l2fwd_LDFLAGS = $(AM_LDFLAGS) -static
 odp_l2fwd_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
 
+noinst_HEADERS = \
+		  $(top_srcdir)/example/example_debug.h
+
 dist_odp_l2fwd_SOURCES = odp_l2fwd.c
diff --git a/example/odp_example/Makefile.am b/example/odp_example/Makefile.am
index 84f2641..8252424 100644
--- a/example/odp_example/Makefile.am
+++ b/example/odp_example/Makefile.am
@@ -4,4 +4,7 @@ bin_PROGRAMS = odp_example
 odp_example_LDFLAGS = $(AM_LDFLAGS) -static
 odp_example_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
 
+noinst_HEADERS = \
+		  $(top_srcdir)/example/example_debug.h
+
 dist_odp_example_SOURCES = odp_example.c
diff --git a/example/packet/Makefile.am b/example/packet/Makefile.am
index 30a0033..a36e29a 100644
--- a/example/packet/Makefile.am
+++ b/example/packet/Makefile.am
@@ -4,4 +4,7 @@ bin_PROGRAMS = odp_pktio
 odp_pktio_LDFLAGS = $(AM_LDFLAGS) -static
 odp_pktio_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
 
+noinst_HEADERS = \
+		  $(top_srcdir)/example/example_debug.h
+
 dist_odp_pktio_SOURCES = odp_pktio.c
diff --git a/example/timer/Makefile.am b/example/timer/Makefile.am
index 30c6105..04d51c4 100644
--- a/example/timer/Makefile.am
+++ b/example/timer/Makefile.am
@@ -4,4 +4,7 @@ bin_PROGRAMS = odp_timer_test
 odp_timer_test_LDFLAGS = $(AM_LDFLAGS) -static
 odp_timer_test_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
 
+noinst_HEADERS = \
+		  $(top_srcdir)/example/example_debug.h
+
 dist_odp_timer_test_SOURCES = odp_timer_test.c
diff --git a/platform/linux-generic/Makefile.am b/platform/linux-generic/Makefile.am
index 1b46416..4535c57 100644
--- a/platform/linux-generic/Makefile.am
+++ b/platform/linux-generic/Makefile.am
@@ -39,6 +39,28 @@ include_HEADERS = \
 		  $(top_srcdir)/platform/linux-generic/include/api/odp_platform_types.h \
 		  $(top_srcdir)/platform/linux-generic/include/api/odp_version.h
 
+noinst_HEADERS = \
+		  ${top_srcdir}/platform/linux-generic/include/odp_align_internal.h \
+		  ${top_srcdir}/platform/linux-generic/include/odp_atomic_internal.h \
+		  ${top_srcdir}/platform/linux-generic/include/odp_buffer_inlines.h \
+		  ${top_srcdir}/platform/linux-generic/include/odp_buffer_internal.h \
+		  ${top_srcdir}/platform/linux-generic/include/odp_buffer_pool_internal.h \
+		  ${top_srcdir}/platform/linux-generic/include/odp_classification_datamodel.h \
+		  ${top_srcdir}/platform/linux-generic/include/odp_classification_inlines.h \
+		  ${top_srcdir}/platform/linux-generic/include/odp_classification_internal.h \
+		  ${top_srcdir}/platform/linux-generic/include/odp_crypto_internal.h \
+		  ${top_srcdir}/platform/linux-generic/include/odp_debug_internal.h \
+		  ${top_srcdir}/platform/linux-generic/include/odp_internal.h \
+		  ${top_srcdir}/platform/linux-generic/include/odp_packet_internal.h \
+		  ${top_srcdir}/platform/linux-generic/include/odp_packet_io_internal.h \
+		  ${top_srcdir}/platform/linux-generic/include/odp_packet_io_queue.h \
+		  ${top_srcdir}/platform/linux-generic/include/odp_packet_socket.h \
+		  ${top_srcdir}/platform/linux-generic/include/odp_queue_internal.h \
+		  ${top_srcdir}/platform/linux-generic/include/odp_schedule_internal.h \
+		  ${top_srcdir}/platform/linux-generic/include/odp_spin_internal.h \
+		  ${top_srcdir}/platform/linux-generic/include/odp_timer_internal.h \
+		  ${top_srcdir}/platform/linux-generic/Makefile.inc
+
 subdirheadersdir = $(includedir)
 subdirheaders_HEADERS = \
 			$(top_srcdir)/helper/include/odph_chksum.h \
diff --git a/test/api_test/Makefile.am b/test/api_test/Makefile.am
index 74e8612..faa08a1 100644
--- a/test/api_test/Makefile.am
+++ b/test/api_test/Makefile.am
@@ -12,6 +12,12 @@ odp_shm_LDFLAGS = $(AM_LDFLAGS) -static
 odp_ring_LDFLAGS = $(AM_LDFLAGS) -static
 odp_timer_ping_LDFLAGS = $(AM_LDFLAGS) -static
 
+noinst_HEADERS = \
+		  $(top_srcdir)/test/api_test/odp_atomic_test.h \
+		  $(top_srcdir)/test/api_test/odp_common.h \
+		  $(top_srcdir)/test/api_test/odp_shm_test.h \
+		  $(top_srcdir)/test/test_debug.h
+
 dist_odp_atomic_SOURCES = odp_atomic_test.c odp_common.c
 dist_odp_shm_SOURCES = odp_shm_test.c odp_common.c
 dist_odp_ring_SOURCES = odp_ring_test.c odp_common.c