diff --git a/example/classifier/Makefile.am b/example/classifier/Makefile.am
index 938f094..e1aaacd 100644
--- a/example/classifier/Makefile.am
+++ b/example/classifier/Makefile.am
@@ -7,4 +7,4 @@ odp_classifier_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
 noinst_HEADERS = \
 		  $(top_srcdir)/example/example_debug.h
 
-dist_odp_classifier_SOURCES = odp_classifier.c
+dist_odp_classifier_SOURCES = odp_classifier.c ../../helper/linux.c
diff --git a/example/generator/Makefile.am b/example/generator/Makefile.am
index fcb5965..8ebea1c 100644
--- a/example/generator/Makefile.am
+++ b/example/generator/Makefile.am
@@ -7,4 +7,4 @@ odp_generator_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
 noinst_HEADERS = \
 		  $(top_srcdir)/example/example_debug.h
 
-dist_odp_generator_SOURCES = odp_generator.c
+dist_odp_generator_SOURCES = odp_generator.c ../../helper/linux.c
diff --git a/example/ipsec/Makefile.am b/example/ipsec/Makefile.am
index 0194f1b..985d465 100644
--- a/example/ipsec/Makefile.am
+++ b/example/ipsec/Makefile.am
@@ -31,4 +31,5 @@ dist_odp_ipsec_SOURCES = odp_ipsec.c \
 			 odp_ipsec_fwd_db.c \
 			 odp_ipsec_loop_db.c \
 			 odp_ipsec_cache.c \
-			 odp_ipsec_stream.c
+			 odp_ipsec_stream.c \
+			 ../../helper/linux.c
diff --git a/example/packet/Makefile.am b/example/packet/Makefile.am
index a36e29a..e916288 100644
--- a/example/packet/Makefile.am
+++ b/example/packet/Makefile.am
@@ -7,4 +7,4 @@ odp_pktio_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
 noinst_HEADERS = \
 		  $(top_srcdir)/example/example_debug.h
 
-dist_odp_pktio_SOURCES = odp_pktio.c
+dist_odp_pktio_SOURCES = odp_pktio.c ../../helper/linux.c
diff --git a/example/timer/Makefile.am b/example/timer/Makefile.am
index 04d51c4..afc6069 100644
--- a/example/timer/Makefile.am
+++ b/example/timer/Makefile.am
@@ -7,4 +7,4 @@ odp_timer_test_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
 noinst_HEADERS = \
 		  $(top_srcdir)/example/example_debug.h
 
-dist_odp_timer_test_SOURCES = odp_timer_test.c
+dist_odp_timer_test_SOURCES = odp_timer_test.c ../../helper/linux.c
diff --git a/platform/linux-generic/Makefile.am b/platform/linux-generic/Makefile.am
index 66f0474..3cbde7d 100644
--- a/platform/linux-generic/Makefile.am
+++ b/platform/linux-generic/Makefile.am
@@ -151,7 +151,6 @@ __LIB__libodp_la_SOURCES = \
 			   odp_event.c \
 			   odp_init.c \
 			   odp_impl.c \
-			   ../../helper/linux.c \
 			   odp_packet.c \
 			   odp_packet_flags.c \
 			   odp_packet_io.c \
diff --git a/test/api_test/Makefile.am b/test/api_test/Makefile.am
index ddbac53..a08af82 100644
--- a/test/api_test/Makefile.am
+++ b/test/api_test/Makefile.am
@@ -10,4 +10,7 @@ noinst_HEADERS = \
 		  $(top_srcdir)/test/api_test/odp_common.h \
 		  $(top_srcdir)/test/test_debug.h
 
-dist_odp_ring_SOURCES = odp_ring_test.c odp_common.c
+dist_odp_ring_SOURCES = odp_ring_test.c \
+			odp_common.c \
+			../../helper/linux.c \
+			../../helper/ring.c
diff --git a/test/performance/Makefile.am b/test/performance/Makefile.am
index f128756..69b15c8 100644
--- a/test/performance/Makefile.am
+++ b/test/performance/Makefile.am
@@ -24,6 +24,7 @@ odp_scheduling_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/test
 noinst_HEADERS = \
 		  $(top_srcdir)/test/test_debug.h
 
-dist_odp_atomic_SOURCES = odp_atomic.c
-dist_odp_scheduling_SOURCES = odp_scheduling.c
-dist_odp_pktio_perf_SOURCES = odp_pktio_perf.c
+dist_odp_atomic_SOURCES = odp_atomic.c  ../../helper/linux.c
+dist_odp_scheduling_SOURCES = odp_scheduling.c ../../helper/linux.c
+dist_odp_pktio_perf_SOURCES = odp_pktio_perf.c  ../../helper/linux.c
+dist_odp_l2fwd_SOURCES = odp_l2fwd.c ../../helper/linux.c
diff --git a/test/validation/Makefile.am b/test/validation/Makefile.am
index 7470d9d..960ade0 100644
--- a/test/validation/Makefile.am
+++ b/test/validation/Makefile.am
@@ -36,7 +36,7 @@ dist_bin_SCRIPTS = odp_pktio_run
 
 bin_PROGRAMS = $(EXECUTABLES) $(COMPILE_ONLY)
 
-ODP_CU_COMMON=common/odp_cunit_common.c
+ODP_CU_COMMON=common/odp_cunit_common.c ../../helper/linux.c
 
 odp_buffer_CFLAGS = $(AM_CFLAGS) -I$(srcdir)/buffer
 dist_odp_buffer_SOURCES = odp_buffer.c $(ODP_CU_COMMON)